//+------------------------------------------------------------------+
//|                                                  MaxMinBands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Julien Loutre"
#property link      "http://www.zenhop.com"
//---- indicator settings
#property  indicator_chart_window
#property indicator_buffers  2
#property  indicator_color1  LightSkyBlue
#property  indicator_color2  Plum

//---- input parameters


extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern int             Band_Period = 120;
//---- buffers
double WWBuffer1[];
double WWBuffer2[];
string indicatorFileName;
bool   returnBars;

int init()
{
   IndicatorDigits(Digits+2);

   SetIndexBuffer(0, WWBuffer1);
   SetIndexBuffer(1, WWBuffer2);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Min/Max Bands");
   return(0);
}

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);   
         if (returnBars) { WWBuffer1[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      
   //
   //
   //
   //
   //
   
      for (int i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            WWBuffer1[i] = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Band_Period,y));
            WWBuffer2[i] = iLow(NULL,TimeFrame,iLowest(NULL,TimeFrame,MODE_LOW,Band_Period,y));
      }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}